-- See the Copyright notice at the end of this file.
--
--
-- All definition of TUPLE classes are in this unique file.
--

class TUPLE -- Empty TUPLE definition.

feature {ANY}
   count: INTEGER is
      do
			Result := 0
      end

   item (i: INTEGER): ANY is
      require
			False
      do
      end
	
end -- TUPLE



class TUPLE [A_] -- One field TUPLE definition.

inherit
   TUPLE
      redefine count, item
      end

creation
   make_1

feature {ANY}
   count: INTEGER is
      do
			Result := 1
      end

   item_1: A_

   set_item_1, set_first (i1: like item_1) is
      do
			item_1 := i1
      ensure
			item_1 = i1
      end

   first: like item_1 is
			-- A well-known alias for `item_1'
      do
			Result := item_1
      end

   make_1 (i1: like item_1) is
      do
			item_1 := i1
      ensure
			item_1 = i1
      end

   item (i: INTEGER): ANY is
      require else
			i = 1
      do
			Result := item_1
      end

end -- TUPLE 1


class TUPLE [A_, B_] -- Two fields TUPLE definition.

inherit
   TUPLE [A_]
      redefine count, item
      end

creation
   make_2

feature {ANY}
   count: INTEGER is
      do
			Result := 2
      end

   item_2: B_

   set_item_2, set_second (i2: like item_2) is
      do
			item_2 := i2
      ensure
			item_2 = i2
      end

   second: like item_2 is
			-- A well-known alias for `item_2'
      do
			Result := item_2
      end

   make_2 (i1: like item_1; i2: like item_2) is
      do
			item_1 := i1
			item_2 := i2
      ensure
			item_1 = i1
			item_2 = i2
      end

   item (i: INTEGER): ANY is
      require else
			i = 2
      do
			inspect
				i
			when 1 then
				Result := item_1
			when 2 then
				Result := item_2
			end
      end

end -- TUPLE 2



class TUPLE [A_, B_, C_] -- Three fields TUPLE definition.

inherit
   TUPLE [A_, B_]
      redefine count, item
      end

creation
   make_3

feature {ANY}
   count: INTEGER is
      do
			Result := 3
      end

   item_3: C_

   set_item_3, set_third (i3: like item_3) is
      do
			item_3 := i3
      ensure
			item_3 = i3
      end

   third: like item_3 is
			-- A well-known alias for `item_3'
      do
			Result := item_3
      end

   make_3 (i1: like item_1; i2: like item_2; i3: like item_3) is
      do
			item_1 := i1
			item_2 := i2
			item_3 := i3
      ensure
			item_1 = i1
			item_2 = i2
			item_3 = i3
      end

   item (i: INTEGER): ANY is
      require else
			i = 3
      do
			inspect i
			when 1 then
				Result := item_1
			when 2 then
				Result := item_2
			when 3 then
				Result := item_3
			end
      end

end -- TUPLE 3
	

class TUPLE [A_, B_, C_, D_] -- Four fields TUPLE definition.

inherit
   TUPLE [A_, B_, C_]
      redefine count, item
      end

creation
   make_4

feature {ANY}
   count: INTEGER is
      do
			Result := 4
      end

   item_4: D_

   set_item_4, set_fourth (i4: like item_4) is
      do
			item_4 := i4
      ensure
			item_4 = i4
      end

   fourth: like item_4 is
			-- A well-known alias for `item_4'
      do
			Result := item_4
      end

   make_4 (i1: like item_1; i2: like item_2; i3: like item_3; i4: like item_4) is
      do
			item_1 := i1
			item_2 := i2
			item_3 := i3
			item_4 := i4
      ensure
			item_1 = i1
			item_2 = i2
			item_3 = i3
			item_4 = i4
      end

   item (i: INTEGER): ANY is
      require else
			i = 4
      do
			inspect i
			when 1 then
				Result := item_1
			when 2 then
				Result := item_2
			when 3 then
				Result := item_3
			when 4 then
				Result := item_4
			end
      end

end -- TUPLE 4



class TUPLE [A_, B_, C_, D_, E_] -- Five fields TUPLE definition.

inherit
   TUPLE [A_, B_, C_, D_]
      redefine count, item
      end

creation
   make_5

feature {ANY}
   count: INTEGER is
      do
			Result := 5
      end

   item_5: E_

   set_item_5, set_fifth (i5: like item_5) is
      do
			item_5 := i5
      ensure
			item_5 = i5
      end

   fifth: like item_5 is
			-- A well-known alias for `item_5'
      do
			Result := item_5
      end

   make_5 (i1: like item_1; i2: like item_2; i3: like item_3; i4: like item_4; i5: like item_5) is
      do
			item_1 := i1
			item_2 := i2
			item_3 := i3
			item_4 := i4
			item_5 := i5
      ensure
			item_1 = i1
			item_2 = i2
			item_3 = i3
			item_4 = i4
			item_5 = i5
      end

   item (i: INTEGER): ANY is
      require else
			i = 5
      do
			inspect i
			when 1 then
				Result := item_1
			when 2 then
				Result := item_2
			when 3 then
				Result := item_3
			when 4 then
				Result := item_4
			when 5 then
				Result := item_5
			end
      end

end -- TUPLE 5


class TUPLE [A_, B_, C_, D_, E_, F_] -- Six fields TUPLE definition.

inherit
   TUPLE [A_, B_, C_, D_, E_]
      redefine count, item
      end

creation
   make_6

feature {ANY}
   count: INTEGER is
      do
			Result := 6
      end

   item_6: F_
	
   set_item_6 (i6: like item_6) is
      do
			item_6 := i6
      ensure
			item_6 = i6
      end
	
   make_6 (i1: like item_1; i2: like item_2; i3: like item_3; i4: like item_4; i5: like item_5; i6: like item_6) is
      do
			item_1 := i1
			item_2 := i2
			item_3 := i3
			item_4 := i4
			item_5 := i5
			item_6 := i6
      ensure
			item_1 = i1
			item_2 = i2
			item_3 = i3
			item_4 = i4
			item_5 = i5
			item_6 = i6
      end
	
   item (i: INTEGER): ANY is
      require else
			i = 6
      do
			inspect i
			when 1 then
				Result := item_1
			when 2 then
				Result := item_2
			when 3 then
				Result := item_3
			when 4 then
				Result := item_4
			when 5 then
				Result := item_5
			when 6 then
				Result := item_6
			end
      end

end -- TUPLE 6
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
