-- See the Copyright notice at the end of this file.
--
class OUTPUT_WATCHED_FILE
	-- File which may be used by some `JOB' as waiting condition.
	-- May be useful to wait socket ready to send more data without locking
	-- the process and/or with timeout capability.

inherit
	TEXT_FILE_WRITE

creation {ANY}
	make, connect_to, connect_for_appending_to

feature {ANY}
	descriptor: INTEGER is
		require
			is_connected
		do
			Result := basic_file_descriptor(output_stream)
		end

feature {}
	basic_file_descriptor (file: POINTER): INTEGER is
		external "plug_in"
		alias "{
	 location: "${sys}runtime"
	 module_name: "basic_file"
	 feature_name: "basic_file_descriptor"
	 }"
		end

end -- class OUTPUT_WATCHED_FILE
--
-- ------------------------------------------------------------------------------------------------------------------------------
-- Copyright notice below. Please read.
--
-- This file is free software, which comes along with SmartEiffel. This software is distributed in the hope that it will be
-- useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
-- You can modify it as you want, provided this footer is kept unaltered, and a notification of the changes is added.
-- You are allowed to redistribute it and sell it, alone or as a part of another product.
--
-- Copyright(C) 1994-2002: INRIA - LORIA (INRIA Lorraine) - ESIAL U.H.P.       - University of Nancy 1 - FRANCE
-- Copyright(C) 2003-2004: INRIA - LORIA (INRIA Lorraine) - I.U.T. Charlemagne - University of Nancy 2 - FRANCE
--
-- Authors: Dominique COLNET, Philippe RIBET, Cyril ADRIAN, Vincent CROIZIER, Frederic MERIZEN
--
-- http://SmartEiffel.loria.fr - SmartEiffel@loria.fr
-- ------------------------------------------------------------------------------------------------------------------------------
